package org.fabimon.FlowerBot;

import org.newdawn.slick.Animation;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Renderable;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.geom.Rectangle;

public class FBFlower {
	private float x;
	private float y;
	private float height;
	private float width;
	
	private boolean dead; 
	
	private Rectangle boundingBox;
	
	private Renderable currentFlower;
	private Image Flower;
	private Image FlowerDead;
	private Image FlowerFuture;
	private Animation FlowerFutureDead;
	
	private int flowerType;
	
	public FBFlower(float x, float y, boolean robot) throws SlickException {
		
		this.x = x;
		this.y = y;
		this.width = 87;
		this.height = 102;
		
		this.boundingBox = new Rectangle(x-(width/2), y - height, width, height);
		
		flowerType = FlowerBotGame.random(0, 5);
		
		Flower = new Image("res/flower/flower"+  flowerType + ".png");
		FlowerDead = new Image("res/flower/flowerDead" +  flowerType + ".png");
		
		FlowerFuture = new Image("res/flower/flowerFuture"+  flowerType + ".png");
		
		FlowerFutureDead = new Animation();
		for (int i = 0; i < 191; i++) {
			FlowerFutureDead.addFrame(new Image("res/flower/flowerFutureDead"+ flowerType +  "/" + i + ".png"), 41);
		}
		FlowerFutureDead.setCurrentFrame(FlowerBotGame.random(0, 191));
		
		if (robot) {
			currentFlower = FlowerFuture;
		} else {
			currentFlower = Flower;
		}
	}
	
	public void update() {
		if(FBGame.isFuture()) {
			if (dead) {
				currentFlower = FlowerFutureDead; 
			} else {
				currentFlower = FlowerFuture;
			}
		} else {
			if (dead) {
				currentFlower = FlowerDead;
			} else {
				currentFlower = Flower;
			}
		}
	}
	
	public void draw(Graphics g) {
		//g.setColor(new Color(180, 180, 180));
		//g.draw(boundingBox);
		
		currentFlower.draw(x-(width/2), y- height);
		
		//g.setColor(new Color(255, 0, 0));
		//g.drawRect(x, y, 1, 1);
	}
	
	public float getHeight() {
		return height;
	}

	public void setHeight(float height) {
		this.height = height;
	}

	public float getWidth() {
		return width;
	}

	public void setWidth(float width) {
		this.width = width;
	}

	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public void setBoundingBox(Rectangle boundingBox) {
		this.boundingBox = boundingBox;
	}

	public boolean isDead() {
		return dead;
	}

	public void setDead(boolean dead) {
		this.dead = dead;
		this.update();
	}

	public float getX() {
		return x;
	}

	public void setX(float x) {
		this.x = x;
	}

	public float getY() {
		return y;
	}

	public void setY(float y) {
		this.y = y;
	}

}
