package org.fabimon.FlowerBot;

import java.awt.Font;
import java.util.ArrayList;

import org.newdawn.slick.Animation;
import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.TrueTypeFont;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

public class FBGame extends BasicGameState {
	private int score = 0;

	private Input input;
	
	private static boolean future = false;

	
	private FBRobot robot;
	private FBSky sky;
	
	private ArrayList<FBFlower> flowers= new ArrayList<FBFlower>();

	private Image ground;
	private Image groundFuture;
	private Image houses;
	private Image sign;
	private Animation signFuture;
	
	private TrueTypeFont trueTypeFont;

	private Image bar;
	
	public void init(GameContainer container, StateBasedGame game) throws SlickException {
		robot = new FBRobot();
		sky = new FBSky();
		input = new Input(800);
		
		ground = new Image("res/ground/ground.png");
		groundFuture = new Image("res/ground/groundFuture.png");
		houses = new Image("res/ground/houses.png");
		sign = new Image("res/ground/sign.png");
		
		//load font
		Font awtFont = new Font("Verdana", Font.BOLD, 30);
		trueTypeFont = new TrueTypeFont(awtFont, false);
		//
		
		bar = new Image("res/ground/bar.png");
		
		signFuture = new Animation();
		signFuture.addFrame(new Image("res/ground/signFuture/0.png"), 100);
		signFuture.addFrame(new Image("res/ground/signFuture/1.png"), 100);
		signFuture.addFrame(new Image("res/ground/signFuture/2.png"), 100);
		signFuture.addFrame(new Image("res/ground/signFuture/3.png"), 100);
		
		generateFlowers(30, false);
	}
	 

	 public void render(GameContainer container, StateBasedGame game, Graphics g) throws SlickException {
		 g.scale(FlowerBotGame.getScale(), FlowerBotGame.getScale());
		
		 if (future) {
			sky.draw();
			groundFuture.draw();
			signFuture.draw(960, 60);
		} else {
			sky.draw();
			houses.draw();
			ground.draw(0, 0);
			sign.draw(960, 60);
		}
			
		for(int i = 0; i < flowers.size(); i++) {
			if (flowers.get(i).getY() <= robot.getY()) {
				flowers.get(i).draw(g);
			}
		}
		
		robot.draw(g);
			
		for(int i = 0; i < flowers.size(); i++) {
			if (flowers.get(i).getY() >= robot.getY()) {
				flowers.get(i).draw(g);
			}
		}

		bar.draw(0, 700);
		trueTypeFont.drawString(1100, 732, "" + score, new Color(Color.white));
	 }
	 

	 public void update(GameContainer container, StateBasedGame game, int delta) {
	    if(input.isKeyDown(Input.KEY_ENTER)) {
			FBRobot.setOil(false);
		}
		
		Shape robotShape = robot.getBoundingBox();
		for(int j = 0; j< flowers.size(); j++) {
			if(robotShape.intersects(flowers.get(j).getBoundingBox()) && input.isKeyDown(Input.KEY_SPACE)) {
				if (!flowers.get(j).isDead()) {
					if(FBGame.isFuture()) {
						if(!FBRobot.isOil()) {
							flowers.get(j).setDead(true);
							score = score - 1;
						} else {
							score++;
						}
					} else {
						flowers.get(j).setDead(true);
						score = score - 1;
					}
				}
			}
			flowers.get(j).update();
		}
		
		sky.update();
			
		if (input.isKeyDown(Input.KEY_UP)) {
			robot.setMoveUp(true);
		} else {
			robot.setMoveUp(false);
		}
			
		if (input.isKeyDown(Input.KEY_DOWN)) {
			robot.setMoveDown(true);
		} else {
			robot.setMoveDown(false);
		}
		
		if (input.isKeyDown(Input.KEY_LEFT)) {
			robot.setMoveLeft(true);
		} else {
			robot.setMoveLeft(false);
		}
		
		if (input.isKeyDown(Input.KEY_RIGHT)) {
			robot.setMoveRight(true);
		} else {
			robot.setMoveRight(false);
		}
		
		if (input.isKeyDown(Input.KEY_SPACE)) {
			robot.setPour(true);
		} else {
			robot.setPour(false);
		}
		
		robot.update();
		
		if (score <= -30 || score > 2000) {
			if (FBGame.isFuture()) {
				if (score > 2000) {
					FBInsScreenPoliceFuture.win = true;
				}				
				game.enterState(6, new FadeOutTransition(Color.black), new FadeInTransition(Color.black));
			} else {				
				flowers.clear();
				generateFlowers(30, true);
				score = 0;
				game.enterState(5, new FadeOutTransition(Color.black), new FadeInTransition(Color.black));
			}
		}
	}

	public int getID() {
		return 2;
	}
	
	public static boolean isFuture() {
		return future;
	}
	
	public static void setFuture(boolean future) {
		FBGame.future = future;
	}


	private void generateFlowers(int amount, boolean future) {
		for(int i = 0; i< amount; i++) {
			try {
				flowers.add(new FBFlower(FlowerBotGame.random(0, 1280), FlowerBotGame.random(400, 700), future));
			} catch (SlickException e) {
				e.printStackTrace();
			}
		}
	}		
}
