package org.fabimon.FlowerBot;

import org.newdawn.slick.Animation;
import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

public class FBInstructionScreen extends BasicGameState {
	private Input input;

	private Animation Pulse;
	private Animation Circle;
	private Animation Bars;
	private Image Frame;
	private Image Text1;
	
	private Image ControllSpace;
	private Image ControllButtons;
	
	private Image ControllOil;
	private Image ControllOilActiv;
	private Image ControllWater;
	private Image ControllWaterActiv;
	private boolean chooseoil; // true = oil 

	private boolean next;
	
	@Override
	public void init(GameContainer arg0, StateBasedGame game) throws SlickException {
		input = new Input(800);

		Pulse = new Animation();
		Pulse.addFrame(new Image("res/instruction/pulse/0.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/1.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/2.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/3.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/4.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/5.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/6.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/7.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/8.png"), 100);
		Pulse.addFrame(new Image("res/instruction/pulse/9.png"), 100);
		
		Bars = new Animation();
		Bars.addFrame(new Image("res/instruction/bars/0.png"), 100);
		Bars.addFrame(new Image("res/instruction/bars/1.png"), 100);
		Bars.addFrame(new Image("res/instruction/bars/2.png"), 100);
		Bars.addFrame(new Image("res/instruction/bars/3.png"), 100);
		Bars.addFrame(new Image("res/instruction/bars/4.png"), 100);
		
		Circle = new Animation();
		Circle.addFrame(new Image("res/instruction/circle/0.png"), 400);
		Circle.addFrame(new Image("res/instruction/circle/1.png"), 400);
		Circle.addFrame(new Image("res/instruction/circle/2.png"), 400);
		
		Frame = new Image("res/instruction/frame.png");
		Text1 = new Image("res/instruction/text/1.png");
		
		ControllSpace = new Image("res/instruction/space.png");
		ControllButtons = new Image("res/instruction/buttons.png");
		
		ControllOil = new Image("res/instruction/tile/oil.png");
		ControllOilActiv = new Image("res/instruction/tile/oilActiv.png");
		ControllWater = new Image("res/instruction/tile/water.png");
		ControllWaterActiv = new Image("res/instruction/tile/waterActiv.png");

	}

	@Override
	public void render(GameContainer arg0, StateBasedGame game, Graphics g) throws SlickException {
		g.scale(FlowerBotGame.getScale(), FlowerBotGame.getScale());
		
		g.setColor(new Color(0, 0, 0));
		g.fillRect(0, 0, 1279, 799);
		
		Pulse.draw(1297-250, 20);
		Bars.draw(1150, 620);
		Circle.draw(20, 20);
		Frame.draw(246, 176);
		
		if (FBGame.isFuture()) {
			if (chooseoil) {
				ControllOilActiv.draw(350, 270);
				ControllWater.draw(670, 270);
			}
			
			if (!chooseoil) {
				ControllOil.draw(350, 270);
				ControllWaterActiv.draw(670, 270);
			}
			
			ControllButtons.draw(250, 660);
		} else {
			Text1.draw(246, 176);
			
			ControllSpace.draw(540, 660);
		}
		
	}

	@Override
	public void update(GameContainer arg0, StateBasedGame game, int delta) throws SlickException {
		if (FBGame.isFuture()) {
			if(input.isKeyDown(Input.KEY_LEFT)) {
				chooseoil = true;
			} 
			
			if(input.isKeyDown(Input.KEY_RIGHT)) {
				chooseoil = false;
			} 
			
			if(input.isKeyDown(Input.KEY_SPACE)) {
				FBRobot.setOil(chooseoil);
				game.enterState(2, new FadeOutTransition(Color.black), new FadeInTransition(Color.black));
			} 
			
		} else {
			if(input.isKeyDown(Input.KEY_SPACE)) {
				next = true;
			}
			
			if(next) {
				game.enterState(2, new FadeOutTransition(Color.black), new FadeInTransition(Color.black));
				next = false;
			}
		}
	}

	@Override
	public int getID() {
		return 1;
	}
}
