package org.fabimon.FlowerBot;


import org.newdawn.slick.*;
import org.newdawn.slick.geom.Rectangle;


public class FBRobot {
	private boolean pour;
	private boolean moveRight;
	private boolean moveLeft;
	private boolean moveUp;
	private boolean moveDown;
	
	private static boolean oil = true;
	
	private boolean direction = true;
	
	private Animation currentAnimation;
		
	private float x = 200;
	private float y = 600;
	private float height;
	private float width;
	private Rectangle boundingBox;

	private Animation AnimationStandLeftWater;
	private Animation AnimationStandLeftWaterActiv;
	private Animation AnimationStandLeftOil;
	private Animation AnimationStandLeftOilActiv;
	private Animation AnimationStandRightWater;
	private Animation AnimationStandRightWaterActiv;
	private Animation AnimationStandRightOil;
	private Animation AnimationStandRightOilActiv;
	
	private Animation AnimationMoveRightWater;
	private Animation AnimationMoveRightWaterActiv;
	private Animation AnimationMoveRightOil;
	private Animation AnimationMoveRightOilActiv;
	private Animation AnimationMoveLeftWater;
	private Animation AnimationMoveLeftWaterActiv;
	private Animation AnimationMoveLeftOil;
	private Animation AnimationMoveLeftOilActiv;
		
	public FBRobot() throws SlickException {
		this.height = 177;
		this.width = 218;
		this.boundingBox = new Rectangle(x-(110/2), y - 50, 110, 50);
		
		AnimationStandRightWater = new Animation();
		AnimationStandRightWater.addFrame(new Image("res/robot/standRightWater/0.png"), 100);
		AnimationStandRightWater.addFrame(new Image("res/robot/standRightWater/1.png"), 100);
		AnimationStandRightWater.addFrame(new Image("res/robot/standRightWater/2.png"), 100);
		AnimationStandRightWater.addFrame(new Image("res/robot/standRightWater/3.png"), 100);
		
		AnimationStandRightWaterActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationStandRightWaterActiv.addFrame(new Image("res/robot/standRightWaterActiv/" + i + ".png"), 41);
		}
		
		AnimationStandRightOil = new Animation();
		AnimationStandRightOil.addFrame(new Image("res/robot/standRightOil/0.png"), 100);
		AnimationStandRightOil.addFrame(new Image("res/robot/standRightOil/1.png"), 100);
		AnimationStandRightOil.addFrame(new Image("res/robot/standRightOil/2.png"), 100);
		AnimationStandRightOil.addFrame(new Image("res/robot/standRightOil/3.png"), 100);
		
		AnimationStandRightOilActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationStandRightOilActiv.addFrame(new Image("res/robot/standRightOilActiv/" + i + ".png"), 41);
		}
		
		AnimationStandLeftWater = new Animation();
		AnimationStandLeftWater.addFrame(new Image("res/robot/standLeftWater/0.png"), 100);
		AnimationStandLeftWater.addFrame(new Image("res/robot/standLeftWater/1.png"), 100);
		AnimationStandLeftWater.addFrame(new Image("res/robot/standLeftWater/2.png"), 100);
		AnimationStandLeftWater.addFrame(new Image("res/robot/standLeftWater/3.png"), 100);
		
		AnimationStandLeftWaterActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationStandLeftWaterActiv.addFrame(new Image("res/robot/standLeftWaterActiv/" + i + ".png"), 41);
		}
		
		AnimationStandLeftOil = new Animation();
		AnimationStandLeftOil.addFrame(new Image("res/robot/standLeftOil/0.png"), 100);
		AnimationStandLeftOil.addFrame(new Image("res/robot/standLeftOil/1.png"), 100);
		AnimationStandLeftOil.addFrame(new Image("res/robot/standLeftOil/2.png"), 100);
		AnimationStandLeftOil.addFrame(new Image("res/robot/standLeftOil/3.png"), 100);
		
		AnimationStandLeftOilActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationStandLeftOilActiv.addFrame(new Image("res/robot/standLeftOilActiv/" + i + ".png"), 41);
		}
		
		AnimationMoveRightWater = new Animation();
		AnimationMoveRightWater.addFrame(new Image("res/robot/moveRightWater/0.png"), 100);
		AnimationMoveRightWater.addFrame(new Image("res/robot/moveRightWater/1.png"), 100);
		AnimationMoveRightWater.addFrame(new Image("res/robot/moveRightWater/2.png"), 100);
		AnimationMoveRightWater.addFrame(new Image("res/robot/moveRightWater/3.png"), 100);
		
		AnimationStandRightWaterActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationStandRightWaterActiv.addFrame(new Image("res/robot/standRightWaterActiv/" + i + ".png"), 41);
		}
		
		AnimationMoveRightOil = new Animation();
		AnimationMoveRightOil.addFrame(new Image("res/robot/moveRightOil/0.png"), 100);
		AnimationMoveRightOil.addFrame(new Image("res/robot/moveRightOil/1.png"), 100);
		AnimationMoveRightOil.addFrame(new Image("res/robot/moveRightOil/2.png"), 100);
		AnimationMoveRightOil.addFrame(new Image("res/robot/moveRightOil/3.png"), 100);
		
		AnimationMoveRightWaterActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationMoveRightWaterActiv.addFrame(new Image("res/robot/moveRightWaterActiv/" + i + ".png"), 20);
		}
		
		AnimationMoveRightOilActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationMoveRightOilActiv.addFrame(new Image("res/robot/moveRightOilActiv/" + i + ".png"), 41);
		}
		
		AnimationMoveLeftWater = new Animation();
		AnimationMoveLeftWater.addFrame(new Image("res/robot/moveLeftWater/0.png"), 100);
		AnimationMoveLeftWater.addFrame(new Image("res/robot/moveLeftWater/1.png"), 100);
		AnimationMoveLeftWater.addFrame(new Image("res/robot/moveLeftWater/2.png"), 100);
		AnimationMoveLeftWater.addFrame(new Image("res/robot/moveLeftWater/3.png"), 100);
	
		AnimationMoveLeftOil = new Animation();
		AnimationMoveLeftOil.addFrame(new Image("res/robot/moveLeftOil/0.png"), 100);
		AnimationMoveLeftOil.addFrame(new Image("res/robot/moveLeftOil/1.png"), 100);
		AnimationMoveLeftOil.addFrame(new Image("res/robot/moveLeftOil/2.png"), 100);
		AnimationMoveLeftOil.addFrame(new Image("res/robot/moveLeftOil/3.png"), 100);
		
		AnimationMoveLeftWaterActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationMoveLeftWaterActiv.addFrame(new Image("res/robot/moveLeftWaterActiv/" + i + ".png"), 41);
		}
		
		AnimationMoveLeftOilActiv = new Animation();
		for (int i = 0; i < 143; i++) {
			AnimationMoveLeftOilActiv.addFrame(new Image("res/robot/moveLeftOilActiv/" + i + ".png"), 41);
		}
		
		currentAnimation = AnimationStandRightOil;
	}
	
	public void update() {
		if (oil) {
			if (direction) {
				currentAnimation = AnimationStandRightOil; //Stand
				if (pour){
					currentAnimation = AnimationStandRightOilActiv;
				}
			} else {
				currentAnimation = AnimationStandLeftOil; //Stand
				if (pour){
					currentAnimation = AnimationStandLeftOilActiv;
				}
			}
			
			if (moveRight && pour) {
				direction = true;
				currentAnimation = AnimationMoveRightOilActiv;
				x = x + 2;
			} else if (moveRight) {
				direction = true;
				currentAnimation = AnimationMoveRightOil;
				x = x + 2;
			}
	
			if (moveLeft && pour) {
				direction = false;
				currentAnimation = AnimationMoveLeftOilActiv;
				x = x - 2;
			} else if (moveLeft) {
				direction = false;
				currentAnimation = AnimationMoveLeftOil;
				x = x - 2;
			}
		} else {
			if (direction) {
				currentAnimation = AnimationStandRightWater; //Stand
				if (pour){
					currentAnimation = AnimationStandRightWaterActiv;
				}
			} else {
				currentAnimation = AnimationStandLeftWater; //Stand
				if (pour){
					currentAnimation = AnimationStandLeftWaterActiv;
				}
			}
			
			if (moveRight && pour) {
				direction = true;
				currentAnimation = AnimationMoveRightWaterActiv;
				x = x + 2;
			} else if (moveRight) {
				direction = true;
				currentAnimation = AnimationMoveRightWater;
				x = x + 2;
			}
	
			if (moveLeft && pour) {
				direction = false;
				currentAnimation = AnimationMoveLeftWaterActiv;
				x = x - 2;
			} else if (moveLeft) {
				direction = false;
				currentAnimation = AnimationMoveLeftWater;
				x = x - 2;
			}
		}

		if (moveUp) {
			if (y < 400) {
				y = 400;
			}
			y = y - 2;
		} else if (moveDown) {
			if (y > 680) {
				y = 680;
			}
			y = y + 2;
		}
		
		boundingBox.setBounds(x-(110/2), y - 50, 110, 50);
	}
	
	public void draw(Graphics g) {
		//g.setColor(new Color(180, 180, 180));
		//g.draw(boundingBox);

		currentAnimation.draw(x-(currentAnimation.getWidth()/2), y - currentAnimation.getHeight());
		
		//g.setColor(new Color(255, 0, 0));
		
		//g.drawRect(x, y, 1, 1);
	}

	public boolean isPour() {
		return pour;
	}

	public void setPour(boolean pour) {
		this.pour = pour;
	}

	public boolean isMoveRight() {
		return moveRight;
	}

	public void setMoveRight(boolean moveRight) {
		this.moveRight = moveRight;
	}

	public boolean isMoveLeft() {
		return moveLeft;
	}

	public void setMoveLeft(boolean moveLeft) {
		this.moveLeft = moveLeft;
	}

	public boolean isMoveUp() {
		return moveUp;
	}

	public void setMoveUp(boolean moveUp) {
		this.moveUp = moveUp;
	}

	public boolean isMoveDown() {
		return moveDown;
	}

	public void setMoveDown(boolean moveDown) {
		this.moveDown = moveDown;
	}

	public float getHeight() {
		return height;
	}

	public void setHeight(float height) {
		this.height = height;
	}

	public float getWidth() {
		return width;
	}

	public void setWidth(float width) {
		this.width = width;
	}
	
	public Rectangle getBoundingBox() {
		return boundingBox;
	}

	public float getX() {
		return x;
	}

	public void setX(float x) {
		this.x = x;
	}

	public float getY() {
		return y;
	}

	public void setY(float y) {
		this.y = y;
	}

	public static boolean isOil() {
		return oil;
	}

	public static void setOil(boolean oil) {
		FBRobot.oil = oil;
	}

}
