package org.fabimon.FlowerBot;

import org.newdawn.slick.Animation;
import org.newdawn.slick.BigImage;
import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

public class FBStartScreen extends BasicGameState {
	
	private Animation LogoIntro;
	private Animation LogoOutro;
	private Input input;
	
	private boolean start = false;

	public void init(GameContainer arg0, StateBasedGame game) throws SlickException {
		input = new Input(800);
		
		LogoIntro = new Animation();
		LogoIntro.setLooping(false);
		for (int i = 0; i< 37; i++) {
			LogoIntro.addFrame(new BigImage("res/start/logo-intro/" + i +".png"), 41);
		}
		
		LogoOutro = new Animation();
		LogoOutro.setLooping(false);
		for (int i = 0; i < 33; i++) {
			LogoOutro.addFrame(new BigImage("res/start/logo-outro/" + i +".png"), 41);
		}
	}

	@Override
	public void update(GameContainer arg0, StateBasedGame game, int g) throws SlickException {
	    if(input.isKeyDown(Input.KEY_SPACE)) {
			start = true;
		}
		
		if(LogoOutro.isStopped()) {
			game.enterState(1, new FadeOutTransition(Color.black), new FadeInTransition(Color.black));
		}
	}
	
	@Override
	public void render(GameContainer arg0, StateBasedGame game, Graphics g) throws SlickException {
		g.scale(FlowerBotGame.getScale(), FlowerBotGame.getScale());
		
		g.setColor(new Color(0, 0, 0));
		g.fillRect(0, 0, 1280, 800);
		
		if (start) {
			LogoOutro.draw(435,200);
		} else {
			LogoIntro.draw(435,200);
		}		
	}

	@Override
	public int getID() {
		return 0;
	}
}
