package org.fabimon.FlowerBot;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.newdawn.slick.AppGameContainer;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;

public class FlowerBotGame extends StateBasedGame {
	public static final int NEW_WIDTH = 800;
	public static final int NEW_HEIGHT = 500;
	
	public static final int NORMAL_WIDTH = 1280;
	public static final int NORMAL_HEIGHT = 800;
	private static float scale =(float) 0.625;
	
	public FlowerBotGame(String gamename) {
		super(gamename);
	}

	public void initStatesList(GameContainer container) throws SlickException {
		addState(new FBStartScreen());
	    addState(new FBGame());
	    addState(new FBInstructionScreen());
	    addState(new FBInsScreenPolice());
	    addState(new FBInsScreenPoliceFuture());
	}

	public static void main(String[] args) {
		try {
			AppGameContainer appgc;
			appgc = new AppGameContainer(new FlowerBotGame("FlowerBot"));
			appgc.setDisplayMode(NEW_WIDTH, NEW_HEIGHT, false);
			//FlowerBotGame.calculateScale();
			appgc.setShowFPS(false);
			appgc.start();
		}
		catch (SlickException ex) {
			Logger.getLogger(FlowerBotGame.class.getName()).log(Level.SEVERE, null, ex);
		}
	}

	public static int random(int low, int high) {
		high++;
		return (int) (Math.random() * (high - low) + low);
	}
	
	public static float random(float low, float high) {
		high++;
		return (float) Math.random() * (high - low) + low;
	}

	public static void calculateScale() {
	    setScale(NEW_WIDTH / NORMAL_WIDTH);
	    System.out.println("Scale: " + FlowerBotGame.scale);
	}

	public static float getScale() {
		return scale;
	}

	public static void setScale(float scale) {
		FlowerBotGame.scale = scale;
	}
}